/*̧قDoxygenpɏĂ܂B*/
//! \file *********************************************************************
//!
//! \brief ̧قUART USB֐܂݂܂B
//!
//! - ߲		: AVRpIAR EWAVRGNU GCC
//! - x޲	: AT90USB162, AT90USB82
//!
//! \author	Atmel Corporation	: http://www.atmel.com \n
//!			xFAQ			: http://support.atmel.no/
//!
//! ***************************************************************************

/* 쌠 (c) 2009, Atmel Corporation S\ς݁B
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳATMELAVRiƂ̊֌WłĕzĎgp邱Ƃł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

/*_____ ݸٰ ____________________________________________________________*/

#include "config.h"
#include "lib_mcu/usb/usb_drv.h"
#include "usb_descriptors.h"

#include "uart_usb_lib.h"

/*_____ ϸ ________________________________________________________________*/

/*_____ ` _______________________________________________________________*/

Uchar rx_counter;

/*_____ 錾 _______________________________________________________________*/

/** 
  * @brief uart_usbײ؏
  */
void uart_usb_init (void)
{
	rx_counter = 0;
}

/** 
  * @brief ̊֐͕USB޽Ŏ󂯎ꂽ𒲂ׂ܂B
  * 
  * @return bit (ǂނׂ޲ĂȂTRUE)
  */
bit uart_usb_test_hit (void)
{
	if(!Is_device_enumerated())
		return FALSE;

	if (!rx_counter)
	{
		Usb_select_endpoint(RX_EP);
		if (Is_usb_receive_out())
		{
			rx_counter = Usb_byte_counter();
			if (!rx_counter)
			{
				Usb_ack_receive_out();
			}
		}
	}
	return (rx_counter!=0);
}

/** 
  * @brief ̊֐USB޽1޲Ăǂ݂܂B
  *
  * USB FIFO1޲Ă݂΁A޲ĂԂ܂BUSB FIFOް݂
  * ΁Å֐USBް҂܂B
  * 
  * @return U8 M޲
  */
char uart_usb_getchar (void)
{
	register Uchar data_rx;

	Usb_select_endpoint(RX_EP);
	if (!rx_counter) while (!uart_usb_test_hit());
	data_rx=Usb_read_byte();
	rx_counter--;
	if (!rx_counter) Usb_ack_receive_out();
	return data_rx;
}

/** 
  * @brief ̊֐USBoɏՕŒ1޲Ă󂯓ꏀ𒲂ׂ܂B
  * 
  * @return Boolean ̧ѳM̂߂̐VK޲ĂƂłꍇTRUE
  */
bit uart_usb_tx_ready (void)
{
	if(!Is_device_enumerated())
		return FALSE;

	if (!Is_usb_write_enabled())
	{
		return FALSE;
	}
	return TRUE;
}

/**
  * @brief ̊֐͐VްUSBMɏՕ𖞂܂B̊ɏՕ͊̏
  * ɑ܂Bt҂Oɂ̊ɏՕj邽߂uart_usb_flush()֐
  * JnĂB
  *
  * @param data_to_send
  *
  * @return
  */
int uart_usb_putchar (int data_to_send)
{
	uart_usb_send_buffer((U8*)&data_to_send, 1);
	return data_to_send;
}

/**
  * @brief ̊֐RAMɏՕ̓eUSBɑM܂B̊֐USBш]
  * ւČIȓ`ԂłB
  *
  * @param U8 *buffer	: ׂRAMɏՕւ߲
  * @param data_to_send	: ׂް
  */
void uart_usb_send_buffer (U8 *buffer, U8 nb_data)
{
	U8 zlp;

	if(!Is_device_enumerated())
		return;

	// 0߹(ZLP)KvvZ
	if(nb_data%TX_EP_SIZE)
	{ zlp=FALSE;}
	else { zlp=TRUE; }

	Usb_select_endpoint(TX_EP);
	while (nb_data)
	{
		while(Is_usb_write_enabled()==FALSE);	// ߲ďҋ@
		while(Is_usb_write_enabled() && nb_data)
		{
			Usb_write_byte(*buffer);
			buffer++;
			nb_data--;
		}
		Usb_ack_in_ready();
	}
	if(zlp)
	{
		while(Is_usb_write_enabled()==FALSE);	// ߲ďҋ@
		Usb_ack_in_ready();
	}
}
